Redmine - Patch #37883

Limit mocha version to < 2.0.0 when Ruby version is < 2.7 to avoid test error
Description

Today, | encountered the following "LoadError: cannot load such file -- ruby2_keywords" error, when executing test with ruby 2.6.

)

% bundle exec rails test
/Users/sanak/Build/rb/redmined42/vendor/bundle/ruby/2.6.0/gems/activesupport-5.2.8.1/1lib/active_sup
port/dependencies.rb:291:in ‘require': cannot load such file —- ruby2_keywords (LoadError)

from /Users/sanak/Build/rb/redmined42/vendor/bundle/ruby/2.6.0/gems/activesupport-5.2.8.1/1ib/a
ctive_support/dependencies.rb:291:in “block in require'

from /Users/sanak/Build/rb/redmined42/vendor/bundle/ruby/2.6.0/gems/activesupport-5.2.8.1/1ib/a
ctive_support/dependencies.rb:257:in "~ load_dependency'

from /Users/sanak/Build/rb/redmined?2/vendor/bundle/ruby/2.6.0/gems/activesupport-5.2.8.1/1ib/a
ctive_support/dependencies.rb:291:in "“require'

from /Users/sanak/Build/rb/redmined42/vendor/bundle/ruby/2.6.0/gems/mocha-2.0.0/1lib/mocha/mock.
rb:1l:in “<top (required)>'

e 2022/11/03: https://github.com/sanak/redmine_text blocks/actions/runs/3350392379/jobs/5616832150#step:12:9

The same test was no problem at 2022/10/29,

e 2022/10/29: https://github.com/sanak/redmine_text_blocks/actions/runs/3350364367

and from checking the installed gem diff, the cause seems to be mocha 2.0.0 which was released at 2022/11/01.

¢ https://rubygems.org/gems/mocha/versions/2.0.0

From the following mocha document, the latest 2.0.0 only supports ruby >= 2.7,

e GitHub: https://github.com/freerange/mocha/blob/main/docs/Mocha/Configuration.html#L569
o Website: https://mocha.jamesmead.org/Mocha/Configuration.html

s0, when ruby < 2.7, mocha should be < 2.0.0.

| upload a patch for that, but | am not sure whether it is enough, so reviewing it is helpful.

Related issues:
Related to Redmine - Patch #39070: Allow using the latest version of mocha ev... Closed

Associated revisions

Revision 21945 - 2022-11-03 04:51 - Go MAEDA

Limit mocha version to < 2.0.0 when Ruby version is < 2.7 to avoid test error "cannot load such file -- ruby2_keywords" (#37883).

Patch by Ko Nagase.

Revision 21946 - 2022-11-03 04:53 - Go MAEDA
Merged r21945 from trunk to 5.0-stable (#37883).

Revision 21947 - 2022-11-03 04:55 - Go MAEDA
Merged r21945 from trunk to 4.2-stable (#37883).
History

#1 - 2022-11-03 04:55 - Go MAEDA

- Subject changed from Limit mocha < 2.0.0 when ruby < 2.7 to avoid test error to Limit mocha version to < 2.0.0 when Ruby version is < 2.7 to avoid
test error

- Status changed from New to Closed
- Assignee set to Go MAEDA

- Target version set to 4.2.9

Committed the fix. Thank you for your contribution.

#2 - 2023-09-18 10:45 - Go MAEDA
- Related to Patch #39070: Allow using the latest version of mocha even when using Ruby < 2.7 added

Files
